Subject: RE: bug#24721: 25.1; Reverse the order of `isearch-message-prefix' prefixes from function advice property

From: Drew Adams <[email-masked]>
Date: Tue, 18 Oct 2016 13:49:12 -0700 (PDT)

> > When there is multiple advice (from `add-function') of
> > `isearch-filter-predicate' that has property `isearch-message-prefix',
> > these prefixes are currently shown left to right in the Isearch prompt,
> > with the first added being on the left and the last added being on the
> > right.
> >
> > I think this is backwards from what a user expects.  I've reversed the
> > order in my own copy, and I think it is more helpful: The first one you
> > see is the latest applied.  Entries are added and removed on the left,
> > not the right.  The most important such prefix is typically the last
> > one applied, and having it on the left makes it more noticeable (IMO).
> 
> "Adjectives in English absolutely have to be in this order:
> opinion-size-age-shape-colour-origin-material-purpose Noun.
> So you can have a lovely little old rectangular green French
> silver whittling knife." - an excerpt from a book called
> "The Elements of Eloquence" by Mark Forsyth.
> http://languagelog.ldc.upenn.edu/nll/?p=27890

We can discuss whether that is nonsense. ;-)
But it is anyway 100% irrelevant here.

> Does a similar natural order exist for Isearch, so prefixes
> absolutely have to be in the order "overwrapped regexp I-search",
> but not "regexp overwrapped I-search"?

Not IMHO.

And the only order that makes sense for multiple predicate filters
is the order of application.

People can disagree, however, about how the sequence of filter
applications should be shown: left-to-right or right-to-left.

Mine is just one opinion.